﻿/*=================================================================================================================

■扉も宝箱も開けられる鍵を持つ敵や同盟は宝箱を優先する

〇概要
　「扉」も「宝箱」も開けられる鍵開けアイテムを所有している敵または同盟ユニットは、デフォルトだと「扉」を優先して開けます。
　これを修正し、「宝箱」を優先して開けるようになります。

〇こんなときに使います
　例えば、扉も宝箱も開けられる鍵開けアイテム「盗賊の鍵」を作ったとします。
　その「盗賊の鍵」を持った敵または同盟の「盗賊」が、次のターンに宝箱をとりそう、となった場合に、次のターンで範囲内の「扉」を開けに行くことがあります。
　これが不自然だと思う場合に使ってください。

〇使い方
　この「扉も宝箱も開けられる鍵を持つ敵や同盟は宝箱を優先する.js」をプロジェクトファイルの「Plugin」フォルダに入れてください。

〇注意
　「扉も宝箱も開けられる鍵」を持っていたとしても、「扉も宝箱も開けられる鍵」より「扉のみを開けられる鍵」がそのユニットのアイテムの所有順の上にある場合は、扉を開けに行きます。

〇履歴
　2017/06/25 公開

〇対応バージョン
　SRPG Studio Version:1.129

〇連絡先
　・シルバーティアラの行方 - お問い合わせフォーム		https://silvertiara.click/other/contact
　・レリーズ（シルバーティアラの行方作者）titterアカウント	https://twitter.com/ReleaseCarte
　・メールアドレス						silvertiaraorder@gmail.com

〇利用規約
　改変：OK
　改変したものを公開：OK
　再配布：OK
　商用での使用：OK
　作成者の偽り：NG
　著作権表記：必要ありません（記載したいという場合は「Release」または「レリーズ」でお願いします）
　作成者を偽らなければ基本的に全部OKです。

=================================================================================================================*/

(function() {

var alias1 = BaseCombinationCollector._setPlaceKeyCombination;
BaseCombinationCollector._setPlaceKeyCombination = function(misc, obj, keyFlag) {

		var rangeMetrics, rangeValueGate, rangeTypeGate, rangeValueTreasure, rangeTypeTreasure;
		
		if (KeyEventChecker.isPairKey(obj)) {
			rangeValueGate = 1;
			rangeTypeGate = SelectionRangeType.MULTI;
			rangeValueTreasure = 0;
			rangeTypeTreasure = SelectionRangeType.SELFONLY;
		}
		else {
			rangeValueGate = obj.getRangeValue();
			rangeTypeGate = obj.getRangeType();
			rangeValueTreasure = obj.getRangeValue();
			rangeTypeTreasure = obj.getRangeType();
		}

		if (keyFlag & KeyFlag.TREASURE) {
			rangeMetrics = StructureBuilder.buildRangeMetrics();
			rangeMetrics.endRange = rangeValueTreasure;
			rangeMetrics.rangeType = rangeTypeTreasure;
			this._setPlaceRangeCombination(misc, PlaceEventFilterFlag.TREASURE, rangeMetrics);
		}

		if (keyFlag & KeyFlag.GATE) {
			rangeMetrics = StructureBuilder.buildRangeMetrics();
			rangeMetrics.endRange = rangeValueGate;
			rangeMetrics.rangeType = rangeTypeGate;
			this._setPlaceRangeCombination(misc, PlaceEventFilterFlag.GATE, rangeMetrics);
		}
};

})();